#include "femTimer.h"

namespace fem
{

Timer::Timer()
{
    reset();
}

Timer::~Timer()
{
    // std::cout << "~Timer()\n";
}

void Timer::start()
{
    running = true;
    t0 = std::chrono::high_resolution_clock::now();
}

void Timer::stop()
{
    telapsed = read();
    t0 = std::chrono::high_resolution_clock::time_point();
    running = false;
}

void Timer::reset()
{
    t0 = std::chrono::high_resolution_clock::time_point();
    telapsed = 0.0;
    running = false;
}

double Timer::read() const
{
    if (running)
    {
        auto tnow = std::chrono::high_resolution_clock::now();
        double dt = std::chrono::duration_cast<std::chrono::duration<double>>(tnow - t0).count();
        return telapsed + dt;
    }
    else
        return telapsed;
}

FEM_API std::ostream &
operator<<(std::ostream &out, Timer const &obj)
{
    out << obj.read();
    return out;
}

} // namespace fem
